/*
 * This file is part of the LibreOffice project.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#ifndef _GLTF_TYPES_H
#define _GLTF_TYPES_H

namespace glTF
{

enum glTFFileType { GLTF_JSON, GLTF_BINARY, GLTF_IMAGE, GLTF_GLSL };
typedef struct
{
    int x;
    int y;
    int width;
    int height;
} glTFViewport;

typedef struct
{
    glTFFileType type;
    char* filename;
    char* buffer;
    int imageheight;
    int imagewidth;
    size_t size;
} glTFFile;

typedef struct
{
    glTFFile**   files;
    size_t       size;
    glTFViewport viewport;
    void*        renderer;
} glTFHandle;

}

#endif
